﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Drawing;
public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            DataTable dt = new DataTable();
            dt.Columns.AddRange(new DataColumn[3] { new DataColumn("Id"), new DataColumn("Name"), new DataColumn("Country") });
            dt.Rows.Add(1, "John Hammond", "");
            dt.Rows.Add(2, "Mudassar Khan", "India");
            dt.Rows.Add(3, "Suzanne Mathews", "France");
            dt.Rows.Add(4, "Robert Schidner", "Russia");
            ViewState["dt"] = dt;
            this.BindGrid();
        }
    }

    protected void BindGrid()
    {
        GridView1.DataSource = ViewState["dt"] as DataTable;
        GridView1.DataBind();
    }

    protected void OnRowCreated(object sender, GridViewRowEventArgs e)
    {
        //Find the Row being edited.
        if (GridView1.EditIndex == e.Row.RowIndex)
        {
            //Loop through all Cells in the Row.
            int index = 0;
            foreach (TableCell cell in e.Row.Cells)
            {
                if (cell.Controls.Count > 0)
                {
                    //Check whether Cell has TextBox.
                    if (cell.Controls[0] is TextBox)
                    {
                        //Reference the TextBox.
                        TextBox textBox = cell.Controls[0] as TextBox;

                        //Assign ID to the TextBox.
                        textBox.ID = "txt" + GridView1.HeaderRow.Cells[index].Text.Replace(" ", "");

                        //Create and assign RequiredFieldValidator to the TextBox.
                        RequiredFieldValidator validator = new RequiredFieldValidator
                        {
                            ControlToValidate = textBox.ID,
                            ForeColor = Color.Red,
                            ErrorMessage = "Required",
                            ValidationGroup = "Update"
                        };
                        cell.Controls.Add(validator);
                    }
                    else
                    {
                        //Add ValidationGroup to the Update Button.
                        LinkButton lnkUpdate = cell.FindControl("lnkUpdate") as LinkButton;
                        lnkUpdate.ValidationGroup = "Update";
                    }
                }
                index++;
            }
        }
    }

    protected void OnRowEditing(object sender, GridViewEditEventArgs e)
    {
        GridView1.EditIndex = e.NewEditIndex;
        this.BindGrid();
    }

    protected void OnUpdate(object sender, EventArgs e)
    {
        GridViewRow row = (sender as LinkButton).NamingContainer as GridViewRow;
        string name = (row.Cells[0].Controls[0] as TextBox).Text;
        string country = (row.Cells[1].Controls[0] as TextBox).Text;
        DataTable dt = ViewState["dt"] as DataTable;
        dt.Rows[row.RowIndex]["Name"] = name;
        dt.Rows[row.RowIndex]["Country"] = country;
        ViewState["dt"] = dt;
        GridView1.EditIndex = -1;
        this.BindGrid();
    }

    protected void OnCancel(object sender, EventArgs e)
    {
        GridView1.EditIndex = -1;
        this.BindGrid();
    }
}