﻿Imports System.Data
Imports System.Drawing

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Dim dt As New DataTable()
            dt.Columns.AddRange(New DataColumn(2) {New DataColumn("Id"), New DataColumn("Name"), New DataColumn("Country")})
            dt.Rows.Add(1, "John Hammond", "")
            dt.Rows.Add(2, "Mudassar Khan", "India")
            dt.Rows.Add(3, "Suzanne Mathews", "France")
            dt.Rows.Add(4, "Robert Schidner", "Russia")
            ViewState("dt") = dt
            Me.BindGrid()
        End If
    End Sub

    Protected Sub BindGrid()
        GridView1.DataSource = TryCast(ViewState("dt"), DataTable)
        GridView1.DataBind()
    End Sub

    Protected Sub OnRowCreated(sender As Object, e As GridViewRowEventArgs)
        'Find the Row being edited.
        If GridView1.EditIndex = e.Row.RowIndex Then
            'Loop through all Cells in the Row.
            Dim index As Integer = 0
            For Each cell As TableCell In e.Row.Cells
                If cell.Controls.Count > 0 Then
                    'Check whether Cell has TextBox.
                    If TypeOf cell.Controls(0) Is TextBox Then
                        'Reference the TextBox.
                        Dim textBox As TextBox = TryCast(cell.Controls(0), TextBox)

                        'Assign ID to the TextBox.
                        textBox.ID = "txt" + GridView1.HeaderRow.Cells(index).Text.Replace(" ", "")

                        'Create and assign RequiredFieldValidator to the TextBox.
                        Dim validator As New RequiredFieldValidator() With { _
                          .ControlToValidate = textBox.ID, _
                          .ForeColor = Color.Red, _
                          .ErrorMessage = "Required", _
                          .ValidationGroup = "Update" _
                        }
                        cell.Controls.Add(validator)
                    Else
                        'Add ValidationGroup to the Update Button.
                        Dim lnkUpdate As LinkButton = TryCast(cell.FindControl("lnkUpdate"), LinkButton)
                        lnkUpdate.ValidationGroup = "Update"
                    End If
                End If
                index += 1
            Next
        End If
    End Sub

    Protected Sub OnRowEditing(sender As Object, e As GridViewEditEventArgs)
        GridView1.EditIndex = e.NewEditIndex
        Me.BindGrid()
    End Sub

    Protected Sub OnUpdate(sender As Object, e As EventArgs)
        Dim row As GridViewRow = TryCast(TryCast(sender, LinkButton).NamingContainer, GridViewRow)
        Dim name As String = TryCast(row.Cells(0).Controls(0), TextBox).Text
        Dim country As String = TryCast(row.Cells(1).Controls(0), TextBox).Text
        Dim dt As DataTable = TryCast(ViewState("dt"), DataTable)
        dt.Rows(row.RowIndex)("Name") = name
        dt.Rows(row.RowIndex)("Country") = country
        ViewState("dt") = dt
        GridView1.EditIndex = -1
        Me.BindGrid()
    End Sub

    Protected Sub OnCancel(sender As Object, e As EventArgs)
        GridView1.EditIndex = -1
        Me.BindGrid()
    End Sub
End Class


